/* Pay close attention to the code below and why it DOES NOT WORK.
 * 
 * There is a subtle issue of scoping when using externally defined 
 * variables inside unnamed functions used as callbacks. 
 * 
 * The ultimate failing is not subtle at all, this code only updates
 * the last of the eight rows because the target specification is 
 * is bound to the last setting by the time any of the callbacks are 
 * called.  Example 1 in this series avoided this problem by creating
 * creating and then calling the getSound function as part of the call
 * back procedure, and in that case the name of the field to be updated
 * was copied correctly at the time of the function definition.
 * 
 * If you wish to really better understand what is going on, you
 * will want to review JavaScript closures
 * 
 * https://www.w3schools.com/js/js_function_closures.asp
 * 
 * If you want to simple move on, take this example and the correct
 * version presented as Example 1 and make sure to follow the pattern
 * established in Example 1.  
 * 
 * Ross Beveridge                                April 29, 2017
 */

var alist;

jQuery(document).ready(function() {
	jQuery.post("animalia.php", {}, function(data, status) {
		addRows(data);
		jQuery("#outp1").html(status);
	})
});

function addRows(lst) {
	var rt = "";
	var tab = document.getElementById('animals');
	var i = tab.rows.length;
	var len = lst.length;
	for (j = len - 1; j >= 0; j--) {
		rt  = "<tr><td>";
		rt += "<a href=\"" + lst[j].url + "\">" + lst[j].name + "</a>";
		rt += "</td>";
		rt += "<td id=\"" + lst[j].name + "_sound\"> ... </td> </tr>";
		var rr = tab.insertRow(i);
		rr.innerHTML = rt;
	}
	for (j = 0; j < len; j++) {
		// getSound(lst[j].name);
		var n = lst[j].name;
		jQuery.post("asound.php", {a : n}, function(data, status) {
			target = "#" + n + "_sound";
	        jQuery(target).text(data);
		})
	}
}

/*function getSound(n) {
	jQuery.post("asound.php", {a : n}, function(data, status) {
		target = "#" + n + "_sound";
        jQuery(target).text(data);
	})
}*/